
!----------------------------------------------------------------------
!  This routine initializes the following grid functions
!  phi pi phiaux piaux 
!  Vaux residre residim 
!----------------------------------------------------------------------
      subroutine initializer0(phi_n,pi_n,Vaux_n,phiaux_n,piaux_n,residre
     &  _n,residim_n,g1_Nr,r,amp,nc,nw)
        implicit none

        include 'globals.inc'

        integer g1_Nr
        real*8  phi_n(1:g1_Nr)
        real*8  pi_n(1:g1_Nr)
        real*8  Vaux_n(1:g1_Nr)
        real*8  phiaux_n(1:g1_Nr)
        real*8  piaux_n(1:g1_Nr)
        real*8  residre_n(1:g1_Nr)
        real*8  residim_n(1:g1_Nr)
        real*8  r(*)
        real*8  amp
        real*8  nc
        real*8  nw
        integer i,j,k

          do i=1, g1_Nr, 1
          phi_n(i)=amp*exp(-((r(i)-nc)/nw)**2)
          end do
          do i=1, g1_Nr, 1
          pi_n(i)=0
          end do
          do i=1, g1_Nr, 1
          phiaux_n(i)=amp*exp(-((r(i)-nc)/nw)**2)
          end do
          do i=1, g1_Nr, 1
          piaux_n(i)=0
          end do
          do i=1, g1_Nr, 1
          Vaux_n(i)=0
          end do
          do i=1, g1_Nr, 1
          residre_n(i)=0
          end do
          do i=1, g1_Nr, 1
          residim_n(i)=0
          end do
        return
      end


!----------------------------------------------------------------------
!  This routine initializes the following grid functions
!  V norm renorm 
!----------------------------------------------------------------------
      subroutine init0(phi_np1,phi_n,pi_np1,pi_n,V_np1,V_n,norm_np1,norm
     &  _n,Vaux_np1,Vaux_n,phiaux_np1,phiaux_n,piaux_np1,piaux_n,residre
     &  _np1,residre_n,residim_np1,residim_n,renorm_np1,renorm_n,g1_Nr,r
     &  ,t,dr,dt,couple,epsiter,iter,vpass)
        implicit none

        include 'globals.inc'

        integer g1_Nr
        real*8  phi_np1(1:g1_Nr)
        real*8  phi_n(1:g1_Nr)
        real*8  pi_np1(1:g1_Nr)
        real*8  pi_n(1:g1_Nr)
        real*8  V_np1(1:g1_Nr)
        real*8  V_n(1:g1_Nr)
        real*8  norm_np1(1:g1_Nr)
        real*8  norm_n(1:g1_Nr)
        real*8  Vaux_np1(1:g1_Nr)
        real*8  Vaux_n(1:g1_Nr)
        real*8  phiaux_np1(1:g1_Nr)
        real*8  phiaux_n(1:g1_Nr)
        real*8  piaux_np1(1:g1_Nr)
        real*8  piaux_n(1:g1_Nr)
        real*8  residre_np1(1:g1_Nr)
        real*8  residre_n(1:g1_Nr)
        real*8  residim_np1(1:g1_Nr)
        real*8  residim_n(1:g1_Nr)
        real*8  renorm_np1(1:g1_Nr)
        real*8  renorm_n(1:g1_Nr)
        real*8  r(*)
        real*8  t
        real*8  dr
        real*8  dt
        real*8  couple
        real*8  epsiter
        integer iter
        integer vpass

c------------------------------------------------------------
c Passes vpass to update0.inc to enable initialization of V
c------------------------------------------------------------
      integer upass
c      real*8 DL(g1_Nr - 1), D(g1_Nr), DU(g1_Nr - 1), B(g1_Nr)
      upass = 1

      call update0(phi_np1,phi_n,pi_np1,pi_n,V_np1,V_n,norm_np1,
     &norm_n,Vaux_np1,
     &Vaux_n,phiaux_np1,phiaux_n,piaux_np1,piaux_n,residre_np1,
     &residre_n,residim_np1,residim_n,renorm_np1,renorm_n,g1_Nr,r,t,
     &dr,dt,couple,
     &epsiter,iter,upass)
     
        return
      end

